# Module name: Passing Parameters by Value
_Skeleton descriptions are typeset in italic text,_
_so please don't remove these descriptions when editing the topic._

## Overview

_Provides a short natural language abstract of the module’s contents._
_Specifies the different levels of teaching._

<table>
  <thead>
    <th>Level</th>
    <th>Objectives</th>
  </thead>
  <tr>
    <td>Foundational</td>
    <td>Defining and calling functions with values</td>
  </tr>
  <tr>
    <td>Main</td>
    <td></td>
  </tr>
  <tr>
    <td>Advanced</td>
    <td></td>
  </tr>
</table>

## Motivation

_Why is this important?_
_Why do we want to learn/teach this topic?_

The fundamental element for code-reuse is a function. For functions to be 
useful, we need to parameterize them. Understanding how to do such is thus
fundamental to programming in any language.

## Topic introduction

_Very brief introduction to the topic._

Explain how to define functions with parameters and call them with values.

## Foundational: Using reference types to avoid copies

### Background/Required Knowledge

A student is able to:

* Explain what a function is

### Student outcomes

_A list of things "a student should be able to" after the curriculum._
_The next word should be an action word and testable in an exam._
_Max 5 items._

A student should be able to:

1. Call a function with any number of parameters using the same number of arguments
2. Define a function with any number of parameters

### Caveats

_This section mentions subtle points to understand, like anything resulting in
implementation-defined, unspecified, or undefined behavior._

### Points to cover

_This section lists important details for each point._

* A function is called by invoking the name of the function, followed by parentheses
* For each parameter in the function signature, a value must be provided, and in the same order
* Multiple values passed to a function are comma-separated
* When defining a function, you must list the parameters with the type first, and parameter name second

## Main: Using references to modify external data 

### Background/Required Knowledge

### Student outcomes

### Caveats

### Points to cover

## Advanced

_These are important topics that are not expected to be covered but provide
guidance where one can continue to investigate this topic in more depth._

